package com.perforce.jdev;

import java.io.File;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import oracle.ide.net.URLFileSystem;
import oracle.ide.net.URLFileSystemHelper;
import oracle.ide.util.IntHashMap;

/** Supports the <tt>p4</tt> protocol. */
public class P4FileSystemHelper extends URLFileSystemHelper  {

   /** Maps host names to port numbers to client roots.*/
   private Map hostMap = new HashMap();

   synchronized String addClient(String host, int port, String root) {
      final IntHashMap ports = (IntHashMap) hostMap.get(host);
      if (ports == null) {
         final IntHashMap val = new IntHashMap();
         val.put(port, root);
         hostMap.put(host, val);
         return null;
      }
      return (String) ports.put(port, root);
   }

   public String getPlatformPathName(URL u) {
      final IntHashMap ports = (IntHashMap) hostMap.get(u.getHost());
      final String root = (String) ports.get(u.getPort());
      final String depot = "/depot"; // FIXME
      final String path = u.getPath().replace('/', File.separatorChar);
      return root + path.substring(depot.length());
   }
   
   static {
      URLFileSystem.registerHelper("p4", new P4FileSystemHelper());
   }

}