package com.perforce.jdev.cm;

import java.util.Arrays;
import java.util.Iterator;

import oracle.ide.Ide;

import oracle.ide.addin.AbstractCommand;

import oracle.ide.model.Connections;

/**
 * Command to create a new P4ConnectionWrapper for the ConnectionManager.
 *
 * @author Paul Krause
 * @version $Revision: #1 $ $Date: 2002/10/05 $
 */
public class NewP4ConnectionCmd extends AbstractCommand  {

   /** Command name for menu item. */
   public static final String NAME = "New P4 Connection";

   /** Command ID for Ide. */
   public static final int ID = Ide.newCmd(NAME);

   /**
    * Creates a new <code>NewP4ConnectionCmd</code> instance.
    * This command has no undo.
    */
   public NewP4ConnectionCmd() {
      super(ID, NO_UNDO, NAME);
   }


   public int doit() throws Exception {
      return 0;
   }

   protected Connections getContextNode() {
      return null;
   }

   protected Iterator getContextNodes() {
      return Arrays.asList(new Object[] { getContextNode() }).iterator();
   }
}
